﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Text;

namespace ServerNodeLib
{
	[Serializable()]
	public class BatchResource
	{
		public BatchResource()
		{
			this.ClientPath = String.Empty;
			this.ServerPath = String.Empty;
			this.BatchResId = Guid.NewGuid();
		}
		/// <summary>
		/// For outgoing and incoming files, this is the path on the client.
		/// </summary>
		public String ClientPath;
		/// <summary>
		/// For outgoing files, this is the path on the server.
		/// For incoming files this is the suggestive filename to store on the server.
		/// You cannot set the incoming file directory here.
		/// </summary>
		public String ServerPath;
		/// <summary>
		/// A guid to uniquely identify the row in the persistent database
		/// </summary>
		public Guid BatchResId;
	}
}