﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ComponentModel;
using System.Runtime.Serialization;

namespace ServerNodeLib
{
	/// <summary>
	/// Captures the result of checking and transfering a resource.
	/// </summary>
	[DataContract()]
	public class ResourceResult
	{
		/// <summary>
		/// The path of the resource in question, local to the client.
		/// </summary>
		[DataMember()]
		public String Path;
		/// <summary>
		/// True if the file already existed on the client machine.
		/// This does not capture whether the Md5 hashes match.
		/// </summary>
		[DataMember()]
		public bool AlreadyExists;
		/// <summary>
		/// True if the file was transfered from the server.
		/// </summary>
		[DataMember()]
		public bool TransferSuccessfully;
	}
}
